;; -*- no-byte-compile: t; -*-
;;; $DOOMDIR/packages.el

;; To install a package with Doom you must declare them here and run 'doom sync'
;; on the command line, then restart Emacs for the changes to take effect -- or
;; use 'M-x doom/reload'.


;; To install SOME-PACKAGE from MELPA, ELPA or emacsmirror:
;;(package! some-package)

;; To install a package directly from a remote git repo, you must specify a
;; `:recipe'. You'll find documentation on what `:recipe' accepts here:
;; https://github.com/radian-software/straight.el#the-recipe-format
;;(package! another-package
;;  :recipe (:host github :repo "username/repo"))

;; If the package you are trying to install does not contain a PACKAGENAME.el
;; file, or is located in a subdirectory of the repo, you'll need to specify
;; `:files' in the `:recipe':
;;(package! this-package
;;  :recipe (:host github :repo "username/repo"
;;           :files ("some-file.el" "src/lisp/*.el")))

;; If you'd like to disable a package included with Doom, you can do so here
;; with the `:disable' property:
;;(package! builtin-package :disable t)

;; You can override the recipe of a built in package without having to specify
;; all the properties for `:recipe'. These will inherit the rest of its recipe
;; from Doom or MELPA/ELPA/Emacsmirror:
;;(package! builtin-package :recipe (:nonrecursive t))
;;(package! builtin-package-2 :recipe (:repo "myfork/package"))

;; Specify a `:branch' to install a package from a particular branch or tag.
;; This is required for some packages whose default branch isn't 'master' (which
;; our package manager can't deal with; see radian-software/straight.el#279)
;;(package! builtin-package :recipe (:branch "develop"))

;; Use `:pin' to specify a particular commit to install.

;; tabs
(package! centaur-tabs)

;; nix
(package! nixpkgs-fmt)

;; copilot
;; (package! copilot
;;  :recipe (:host github :repo "zerolfx/copilot.el" :files ("*.el" "dist")))
;;;;;;;;;;;;;;;;;;;;;;;;;

;; gptel
(package! gptel :recipe (:type git :host nil :repo "https://github.com/karthink/gptel.git" :branch "master"))
;; gptel-extensions
(package! gptel-extensions :recipe (:host github :repo "kamushadenes/gptel-extensions.el"))
;; gptcommit
(package! llm)
(package! magit-gptcommit :recipe (:host github :repo "douo/magit-gptcommit" :branch "master"))
;;;;;;;;;;;;;;;;;;;;;;;;;


;; rust analyzer extensions for eglot + treesit foledr

(package! treesit-fold :recipe (:host github :repo "emacs-tree-sitter/treesit-fold"))
(package! eglot-x :recipe (:host github :repo "nemethf/eglot-x"))
(package! eglot-booster :recipe (:type git :host nil :repo "https://github.com/jdtsmith/eglot-booster.git" :branch "main"))

(package! eat :recipe (:type git
                       :host codeberg
                       :repo "akib/emacs-eat"
                       :files ("*.el" ("term" "term/*.el") "*.texi"
                               "*.ti" ("terminfo/e" "terminfo/e/*")
                               ("terminfo/65" "terminfo/65/*")
                               ("integration" "integration/*")
                               (:exclude ".dir-locals.el" "*-tests.el"))))
;;

;; B-D
(package! cognitive-complexity
  :recipe (:host github :repo "emacs-vs/cognitive-complexity"))

(package! codemetrics
  :recipe (:host github :repo "emacs-vs/codemetrics"))

;; Can likely be removed once fixed in dommemacs https://github.com/doomemacs/doomemacs/issues/8287
(package! eldoc :built-in t)
(package! track-changes :built-in t)
;;;;;;;;;;;

(package! treesit-auto)

(package! tabby
  :recipe (:host github :files ("*.el" "node_scripts")
           :repo "alan-w-255/tabby.el"))

(package! activity-watch-mode)
;; Doom's packages are pinned to a specific commit and updated from release to
;; release. The `unpin!' macro allows you to unpin single packages...
;;(unpin! pinned-package)
;; ...or multiple packages
;;(unpin! pinned-package another-pinned-package)
;; ...Or *all* packages (NOT RECOMMENDED; will likely break things)
;;(unpin! t)
